' mandelbrot32-20180317-b

con
  xmin=round(-2.0*float(1<<24))
  xmax=round( 2.0*float(1<<24))

  ymin=round(-2.0*float(1<<24))
  ymax=round( 2.0*float(1<<24))

  maxiter=15

  MPX=799 ' 0..MPX
  MPY=799 ' 0..MPY

  dx=(xmax-xmin)/MPX
  dy=(ymax-ymin)/MPY

  c4=4<<24

obj
  ser : "SimpleSerial.cog"

pub start | c,cx,cy,sy,x,y,x2,y2,iter,px,py

  ser.__cognew
  ser.start(115200)
  ser.str(string(27,80,113)) ' enter sixel mode ... ESC P q

  cy:=ymin
  sy:=0
  repeat py from 0 to MPY
    cx:=xmin
    repeat px from 0 to MPX
      x:=0
      y:=0
      iter:=0
      repeat while iter=<maxiter
        x2:=(x**x)<<8 | (x*x)>>24 ' x*x
        y2:=(y**y)<<8 | (y*y)>>24 ' y*y
        if x2+y2>c4
          quit
        y:=((x**y)<<9 | (x*y)>>23)+cy ' 2*x*y+cy
        x:=x2-y2+cx
        iter+=1
      cx+=dx
      ser.tx(((iter&1)<<sy)+63)
    cy+=dy
    ser.tx(36) ' sixel cr ... $
    sy+=1
    if sy==6
      sy:=0
      ser.tx(45) ' sixel lf ... -

  ser.str(string(27,92)) ' leave sixel mode ... ESC \

  waitcnt(clkfreq+cnt)
  ser.__cogstop
